c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine zqrqh(m,n,R,ldr,c,s)
c purpose:      brings an upper trapezoidal matrix R into upper
c               Hessenberg form using min(m-1,n) Givens rotations.
c               (complex version)
c arguments:
c m (in)        number of rows of the matrix R
c n (in)        number of columns of the matrix R
c R (io)        on entry, the upper Hessenberg matrix R
c               on exit, the updated upper trapezoidal matrix
c ldr (in)      leading dimension of R, >= m
c c(in)         rotation cosines, size at least min(m-1,n)
c s(in)         rotation sines, size at least min(m-1,n)
c
      integer m,n,ldr
      double complex R(ldr,*),s(*)
      double precision c(*)
      external xerbla
      double complex t
      integer info,i,ii,j
c quick return if possible.
      if (m == 0 .or. m == 1 .or. n == 0) return
c check arguments.
      info = 0
      if (m < 0) then
        info = 1
      else if (n < 0) then
        info = 2
      else if (ldr < m) then
        info = 4
      end if
      if (info /= 0) then
        call xerbla('ZQRQH',info)
        return
      end if
      do i = 1,n
c apply stored rotations, column-wise
        ii = min(m-1,i)
        t = R(ii+1,i)
        do j = ii,1,-1
          R(j+1,i) = c(j)*t - conjg(s(j))*R(j,i)
          t = c(j)*R(j,i) + s(j)*t
        end do
        R(1,i) = t
      end do
      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine dgqvec(m,n,Q,ldq,u)
c purpose:      given an orthogonal m-by-n matrix Q, n < m, generates
c               a vector u such that Q'*u = 0 and norm(u) = 1.
c arguments:
c m (in)        number of rows of matrix Q.
c n (in)        number of columns of matrix Q.
c Q (in)        the orthogonal matrix Q.
c ldq (in)      leading dimension of Q.
c u (out)       the generated vector.
c
      integer m,n,ldq
      double precision Q(ldq,*),u(*)
      external ddot,daxpy,dnrm2,dscal,xerbla
      double precision ddot,dnrm2,r
      integer info,i,j
c quick return if possible.
      if (m == 0) return
      if (n == 0) then
        u(1) = 1d0
        do i = 2,m
          u(i) = 0d0
        end do
        return
      end if
c check arguments.
      info = 0
      if (m < 0) then
        info = 1
      else if (n < 0) then
        info = 2
      else if (ldq < m) then
        info = 4
      end if
      if (info /= 0) then
        call xerbla('DGQVEC',info)
        return
      end if

      j = 1
 10   continue
c probe j-th canonical unit vector.
      do i = 1,m
        u(i) = 0d0
      end do
      u(j) = 1d0
c form u - Q*Q'*u
      do i = 1,n
        r = ddot(m,Q(1,i),1,u,1)
        call daxpy(m,-r,Q(1,i),1,u,1)
      end do
      r = dnrm2(m,u,1)
      if (r == 0d0) then
        j = j + 1
        if (j > n) then
c this is fatal, and in theory, it can't happen.
          stop 'fatal: impossible condition in DGQVEC'
        else
          j = j + 1
          goto 10
        end if
      end if
      call dscal(m,1d0/r,u,1)
      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine zaxcpy(n,a,x,incx,y,incy)
c purpose:      constant times a conjugated vector plus a vector.
c arguments:
c n (in)        vector length
c a (in)        complex factor
c x (in)        added vector
c incx (in)     x increments
c y (io)        accumulator vector
c incy (in)     y increments
c
      integer n,incx,incy
      double complex a,x(*),y(*)
      integer i,ix,iy
c quick return if possible.
      if (n <= 0) return
      if (incx /= 1 .or. incy /= 1) then
c code for unequal increments or equal increments not equal to 1
        ix = 1
        iy = 1
        if (incx.lt.0) ix = (-n+1)*incx + 1
        if (incy.lt.0) iy = (-n+1)*incy + 1
        do i = 1,n
          y(iy) = y(iy) + a*conjg(x(ix))
          ix = ix + incx
          iy = iy + incy
        end do
      else
c code for both increments equal to 1
        do i = 1,n
           y(i) = y(i) + a*conjg(x(i))
        end do
      end if
      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine cqrtv1(n,u,w)
c purpose:      generates a sequence of n-1 Givens rotations that
c               eliminate all but the first element of a vector u.
c arguments:
c n (in)        the length of the vector u
c u (io)        on entry, the vector u.
c               on exit, u(2:n) contains the rotation sines, u(1)
c               contains the remaining element.
c w (o)         on exit, w contains the rotation cosines.
c
      integer n
      complex u(*)
      real w(*)
      external clartg
      complex rr,t
      integer i
c quick return if possible.
      if (n <= 0) return
      rr = u(n)
      do i = n-1,1,-1
        call clartg(u(i),rr,w(i),u(i+1),t)
        rr = t
      end do
      u(1) = rr
      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine sqrshc(m,n,k,Q,ldq,R,ldr,i,j,w)
c purpose:      updates a QR factorization after circular shift of
c               columns.
c               i.e., given an m-by-k orthogonal matrix Q, an k-by-n
c               upper trapezoidal matrix R and index j in the range
c               1:n+1, this subroutine updates the matrix Q -> Q1 and
c               R -> R1 so that Q1 is again orthogonal, R1 upper
c               trapezoidal, and
c               Q1*R1 = A(:,p), where A = Q*R and p is the permutation
c               [1:i-1,shift(i:j,-1),j+1:n] if i < j  or
c               [1:j-1,shift(j:i,+1),i+1:n] if j < i.
c               (real version)
c arguments:
c m (in)        number of rows of the matrix Q.
c n (in)        number of columns of the matrix R.
c k (in)        number of columns of Q1, and rows of R1. Must be
c               either k = m (full Q) or k = n <= m (economical form).
c Q (io)        on entry, the unitary m-by-k matrix Q.
c               on exit, the updated matrix Q1.
c ldq (in)      leading dimension of Q. ldq >= m.
c R (io)        on entry, the original matrix R.
c               on exit, the updated matrix R1.
c ldr (in)      leading dimension of R. ldr >= k.
c i (in)        the first index determining the range (see above)
c j (in)        the second index determining the range (see above)
c w (o)         a workspace vector of size 2*k.
c
      integer m,n,k,ldq,ldr,i,j
      real Q(ldq,*),R(ldr,*),w(*)
      external xerbla,scopy,sqrtv1,sqrqh,sqhqr
      integer info,jj,kk,l
c quick return if possible.
      if (m == 0 .or. n == 1) return
      info = 0
c check arguments.
      if (m < 0) then
        info = 1
      else if (n < 0) then
        info = 2
      else if (k /= m .and. (k /= n .or. n > m)) then
        info = 3
      else if (i < 1 .or. i > n) then
        info = 6
      else if (j < 1 .or. j > n) then
        info = 7
      end if
      if (info /= 0) then
        call xerbla('SQRSHC',info)
        return
      end if

      if (i < j) then
c shift columns
        call scopy(k,R(1,i),1,w,1)
        do l = i,j-1
          call scopy(k,R(1,l+1),1,R(1,l),1)
        end do
        call scopy(k,w,1,R(1,j),1)
c retriangularize
        if (i < k) then
          kk = min(k,j)
          call sqhqr(kk+1-i,n+1-i,R(i,i),ldr,w(k+1),w)
c apply rotations to Q.
          call sqrot('F',m,kk+1-i,Q(1,i),ldq,w(k+1),w)
        end if
      else if (j < i) then
c shift columns
        call scopy(k,R(1,i),1,w,1)
        do l = i,j+1,-1
          call scopy(k,R(1,l-1),1,R(1,l),1)
        end do
        call scopy(k,w,1,R(1,j),1)
c retriangularize
        if (j < k) then
          jj = min(j+1,n)
          kk = min(k,i)
c eliminate the introduced spike.
          call sqrtv1(kk+1-j,R(j,j),w(k+1))
c apply rotations to R
          call sqrqh(kk+1-j,n-j,R(j,jj),ldr,w(k+1),R(j+1,j))
c apply rotations to Q
          call sqrot('B',m,kk+1-j,Q(1,j),ldq,w(k+1),R(j+1,j))
c zero spike.
          do l = j+1,kk
            R(l,j) = 0e0
          end do
        end if
      end if
      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine cqrinc(m,n,k,Q,ldq,R,ldr,j,x,rw)
c purpose:      updates a QR factorization after inserting a new
c               column.
c               i.e., given an m-by-k unitary matrix Q, an m-by-n upper
c               trapezoidal matrix R and index j in the range 1:n+1,
c               this subroutine updates the matrix Q -> Q1 and R -> R1
c               so that Q1 is again unitary, R1 upper trapezoidal, and
c               Q1*R1 = [A(:,1:j-1); x; A(:,j:n)], where A = Q*R.
c               (complex version)
c arguments:
c m (in)        number of rows of the matrix Q.
c n (in)        number of columns of the matrix R.
c k (in)        number of columns of Q, and rows of R. Must be
c               either k = m (full Q) or k = n <= m (economical form,
c               basis dimension will increase).
c Q (io)        on entry, the unitary m-by-k matrix Q.
c               on exit, the updated matrix Q1.
c ldq (in)      leading dimension of Q. ldq >= m.
c R (io)        on entry, the original matrix R.
c               on exit, the updated matrix R1.
c ldr (in)      leading dimension of R. ldr >= min(m,n+1).
c j (in)        the position of the new column in R1
c x (in)        the column being inserted
c rw (out)      a real workspace vector of size k.
c
      integer m,n,k,ldq,ldr,j
      complex Q(ldq,*),R(ldr,*),x(*)
      real rw(*)
      external cqrtv1,cqrqh,cqrot
      external xerbla,ccopy,cdotc,caxpy,csscal,scnrm2
      complex cdotc
      real scnrm2,rx
      integer info,i,k1
      logical full
c quick return if possible.
      if (m == 0) return
c check arguments.
      info = 0
      if (m < 0) then
        info = 1
      else if (n < 0) then
        info = 2
      else if (k /= m .and. (k /= n .or. n >= m)) then
        info = 3
      else if (ldq < m) then
        info = 5
      else if (ldr < min(m,k+1)) then
        info = 7
      else if (j < 1 .or. j > n+1) then
        info = 8
      end if
      if (info /= 0) then
        call xerbla('CQRINC',info)
        return
      end if

      full = k == m
c insert empty column at j-th position
      do i = n,j,-1
        call ccopy(k,R(1,i),1,R(1,i+1),1)
      end do
c insert Q'*u into R. In the nonfull case, form also u-Q*Q'*u.
      if (full) then
        k1 = k
        do i = 1,k
          R(i,j) = cdotc(m,Q(1,i),1,x,1)
        end do
      else
        k1 = k + 1
c zero last row of R
        do i = 1,n+1
          R(k1,i) = 0e0
        end do
        call ccopy(m,x,1,Q(1,k1),1)
        do i = 1,k
          R(i,j) = cdotc(m,Q(1,i),1,Q(1,k1),1)
          call caxpy(m,-R(i,j),Q(1,i),1,Q(1,k1),1)
        end do
c get norm of the inserted column
        rx = scnrm2(m,Q(1,k1),1)
        R(k1,j) = rx
        if (rx == 0e0) then
c in the rare case when rx is exact zero, we still need to provide
c a valid orthogonal unit vector. The details are boring, so handle
c that elsewhere.
          call cgqvec(m,k,Q,ldq,Q(1,k1))
        else
c otherwise, just normalize the added column.
          call csscal(m,1e0/rx,Q(1,k1),1)
        end if
      end if
c maybe we're finished.
      if (j > k) return
c eliminate the spike.
      call cqrtv1(k1+1-j,R(j,j),rw)
c apply rotations to R(j:k,j:n).
      if (j <= n) call cqrqh(k1+1-j,n+1-j,R(j,j+1),ldr,rw,R(j+1,j))
c apply rotations to Q(:,j:k).
      call cqrot('B',m,k1+1-j,Q(1,j),ldq,rw,R(j+1,j))
c zero spike.
      do i = j+1,k1
        R(i,j) = 0e0
      end do
      end subroutine

c Copyright (C) 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine clu1up(m,n,L,ldl,R,ldr,u,v)
c purpose:      updates an LU factorization after rank-1 modification
c               i.e., given an m-by-k lower-triangular matrix L with unit
c               diagonal and a k-by-n upper-trapezoidal matrix R,
c               where k = min(m,n),
c               this subroutine updates L -> L1 and R -> R1 so that
c               L is again lower unit triangular, R upper trapezoidal,
c               and L1*R1 = L*R + u*v.'.
c               (complex version)
c arguments:
c m (in)        order of the matrix L.
c n (in)        number of columns of the matrix U.
c L (io)        on entry, the unit lower triangular matrix L.
c               on exit, the updated matrix L1.
c ldl (in)      the leading dimension of L. ldl >= m.
c R (io)        on entry, the upper trapezoidal m-by-n matrix R.
c               on exit, the updated matrix R1.
c ldr (in)      the leading dimension of R. ldr >= min(m,n).
c u (io)        the left m-vector. On exit, if k < m, u is destroyed.
c v (io)        the right n-vector. On exit, v is destroyed.
c
c REMARK:       Algorithm is due to
c               J. Bennett: Triangular factors of modified matrices,
c                           Numerische Mathematik, 7 (1965)
c
      integer m,n,ldl,ldr
      complex L(ldl,*),R(ldr,*),u(*),v(*)
      complex ui,vi
      integer k,info,i,j
      external xerbla
c quick return if possible.
      k = min(m,n)
      if (k == 0) return
c check arguments.
      info = 0
      if (m < 0) then
        info = 1
      else if (n < 0) then
        info = 2
      else if (ldl < m) then
        info = 4
      else if (ldr < k) then
        info = 6
      endif
      if (info /= 0) then
        call xerbla('CLU1UP',info)
        return
      end if

c The Bennett algorithm, modified for column-major access.
c The leading part.
      do i = 1,k
c prefetch        
        ui = u(i)
        vi = v(i)
c delayed R update        
        do j = 1,i-1
          R(j,i) = R(j,i) + u(j)*vi
          vi = vi - v(j)*R(j,i)
        end do
c diagonal update        
        R(i,i) = R(i,i) + ui*vi
        vi = vi/R(i,i)
c L update        
        do j = i+1,m
          u(j) = u(j) - ui*L(j,i)
          L(j,i) = L(j,i) + u(j)*vi
        end do
        u(i) = ui
        v(i) = vi
      end do

c Finish the trailing part of R if needed.
      do i = k+1,n
        vi = v(i)
        do j = 1,k
          R(j,i) = R(j,i) + u(j)*vi
          vi = vi - v(j)*R(j,i)
        end do
        v(i) = vi
      end do
      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine dqrot(dir,m,n,Q,ldq,c,s)
c purpose:      Apply a sequence of inv. rotations from right
c
c arguments:
c dir (in)      if 'B' or 'b', rotations are applied from backwards
c               if 'F' or 'f', from forwards.
c m (in)        number of rows of matrix Q
c n (in)        number of columns of the matrix Q
c Q (io)        on entry, the matrix Q
c               on exit, the updated matrix Q1
c ldq (in)      the leading dimension of Q
c c (in)        n-1 rotation cosines
c s (in)        n-1 rotation sines
c
      character dir
      integer m,n,ldq
      double precision Q(ldq,*),c(*),s(*)
      external xerbla, drot,lsame
      logical lsame,fwd
      integer info,i
c quick return if possible
      if (m == 0 .or. n == 0 .or. n == 1) return
c check arguments.
      info = 0
      fwd = lsame(dir,'F')
      if (.not.(fwd .or. lsame(dir,'B'))) then
        info = 1
      else if (m < 0) then
        info = 2
      else if (n < 0) then
        info = 3
      else if (ldq < m) then
        info = 5
      end if
      if (info /= 0) then
        call xerbla('DQROT',info)
        return
      end if

      if (fwd) then
        do i = 1,n-1
          call drot(m,Q(1,i),1,Q(1,i+1),1,c(i),s(i))
        end do
      else
        do i = n-1,1,-1
          call drot(m,Q(1,i),1,Q(1,i+1),1,c(i),s(i))
        end do
      end if
      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine cqrinr(m,n,Q,ldq,R,ldr,j,x,rw)
c purpose:      updates a QR factorization after inserting a new
c               row.
c               i.e., given an m-by-m unitary matrix Q, an m-by-n
c               upper trapezoidal matrix R and index j in the range
c               1:m+1, this subroutine updates Q -> Q1  and R -> R1
c               so that Q1 is again unitary, R1 upper trapezoidal,
c               and Q1*R1 = [A(1:j-1,:); x; A(j:m,:)], where A = Q*R.
c               (complex version)
c arguments:
c m (in)        number of rows of the matrix Q.
c n (in)        number of columns of the matrix R.
c Q (io)        on entry, the unitary matrix Q.
c               on exit, the updated matrix Q1.
c ldq (in)      leading dimension of Q. ldq >= m+1.
c R (io)        on entry, the original matrix R.
c               on exit, the updated matrix R1.
c ldr (in)      leading dimension of R. ldr >= m+1.
c j (in)        the position of the new row in R1
c x (io)        on entry, the row being added
c               on exit, x is destroyed.
c rw (out)      a real workspace vector of size min(m,n).
c
      integer m,n,j,ldq,ldr
      complex Q(ldq,*),R(ldr,*),x(*)
      real rw(*)
      external xerbla,ccopy,cqhqr,cqrot
      integer info,i,k
c check arguments
      info = 0
      if (n < 0) then
        info = 2
      else if (j < 1 .or. j > m+1) then
        info = 7
      end if
      if (info /= 0) then
        call xerbla('CQRINR',info)
        return
      end if
c permute the columns of Q1 and rows of R1 so that c the new row ends
c up being the topmost row of R1.
      do i = m,1,-1
        if (j > 1) then
          call ccopy(j-1,Q(1,i),1,Q(1,i+1),1)
        end if
        Q(j,i+1) = 0e0
        if (j <= m) then
          call ccopy(m+1-j,Q(j,i),1,Q(j+1,i+1),1)
        end if
      end do
c set up the 1st column
      do i = 1,j-1
        Q(i,1) = 0e0
      end do
      Q(j,1) = 1e0
      do i = j+1,m+1
        Q(i,1) = 0e0
      end do
c set up the new matrix R1
      do k = 1,n
        if (k < m) R(m+1,k) = 0e0
        do i = min(m,k),1,-1
          R(i+1,k) = R(i,k)
        end do
        R(1,k) = x(k)
      end do
c retriangularize R
      call cqhqr(m+1,n,R,ldr,rw,x)
c apply rotations to Q
      call cqrot('F',m+1,min(m,n)+1,Q,ldq,rw,x)
      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine sch1up(n,R,ldr,u,w)
c purpose:      given an upper triangular matrix R that is a Cholesky
c               factor of a symmetric positive definite matrix A, i.e.
c               A = R'*R, this subroutine updates R -> R1 so that
c               R1'*R1 = A + u*u'
c               (real version)
c arguments:
c n (in)        the order of matrix R
c R (io)        on entry, the upper triangular matrix R
c               on exit, the updated matrix R1
c ldr (in)      leading dimension of R. ldr >= n.
c u (io)        the vector determining the rank-1 update
c               on exit, u contains the rotation sines
c               used to transform R to R1.
c w (out)       cosine parts of rotations.
c
      integer n,ldr
      real R(ldr,*),u(*)
      real w(*)
      external slartg
      real rr,ui,t
      integer i,j

      do i = 1,n
c apply stored rotations, column-wise
        ui = u(i)
        do j = 1,i-1
          t = w(j)*R(j,i) + u(j)*ui
          ui = w(j)*ui - u(j)*R(j,i)
          R(j,i) = t
        end do
c generate next rotation
        call slartg(R(i,i),ui,w(i),u(i),rr)
        R(i,i) = rr
      end do
      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine zch1dn(n,R,ldr,u,rw,info)
c purpose:      given an upper triangular matrix R that is a Cholesky
c               factor of a hermitian positive definite matrix A, i.e.
c               A = R'*R, this subroutine downdates R -> R1 so that
c               R1'*R1 = A - u*u'
c               (complex version)
c arguments:
c n (in)        the order of matrix R
c R (io)        on entry, the upper triangular matrix R
c               on exit, the updated matrix R1
c ldr (in)      leading dimension of R. ldr >= n.
c u (io)        the vector determining the rank-1 update
c               on exit, u contains the reflector sines
c               used to transform R to R1.
c rw (out)      cosine parts of reflectors.
c
c info (out)    on exit, error code:
c                info = 0: success.
c                info = 1: update violates positive-definiteness.
c                info = 2: R is singular.
c
      integer n,ldr
      double complex R(ldr,*),u(*)
      double precision rw(*)
      integer info
      external ztrsv,zlartg,dznrm2
      double complex crho,rr,ui,t
      double precision dznrm2,rho
      integer i,j

c quick return if possible.
      if (n == 0) return
c check arguments.
      info = 0
      if (n < 0) then
        info = -1
      else if (ldr < n) then
        info = -3
      end if
      if (info /= 0) then
        call xerbla('ZCH1DN',-info)
        return
      end if

c check for singularity of R.
      do i = 1,n
        if (R(i,i) == 0d0) goto 20
      end do
c form R' \ u
      call ztrsv('U','C','N',n,R,ldr,u,1)
      rho = dznrm2(n,u,1)
c check positive definiteness
      rho = 1 - rho**2
      if (rho <= 0d0) goto 10
      crho = sqrt(rho)
c eliminate R' \ u
      do i = n,1,-1
        ui = u(i)
c generate next rotation
        call zlartg(crho,ui,rw(i),u(i),rr)
        crho = rr
      end do
c apply rotations
      do i = n,1,-1
        ui = 0d0
        do j = i,1,-1
          t = rw(j)*ui + u(j)*R(j,i)
          R(j,i) = rw(j)*R(j,i) - conjg(u(j))*ui
          ui = t
        end do
      end do

c normal return
      return
c error returns
 10   info = 1
      return
 20   info = 2
      return
      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine sqr1up(m,n,k,Q,ldq,R,ldr,u,v,w)
c purpose:      updates a QR factorization after rank-1 modification
c               i.e., given a m-by-k orthogonal Q and m-by-n upper
c               trapezoidal R, an m-vector u and n-vector v,
c               this subroutine updates Q -> Q1 and R -> R1 so that
c               Q1*R1 = Q*R + u*v', and Q1 is again orthonormal
c               and R1 upper trapezoidal.
c               (real version)
c arguments:
c m (in)        number of rows of the matrix Q.
c n (in)        number of columns of the matrix R.
c k (in)        number of columns of Q, and rows of R. Must be
c               either k = m (full Q) or k = n < m (economical form).
c Q (io)        on entry, the orthogonal m-by-k matrix Q.
c               on exit, the updated matrix Q1.
c ldq (in)      the leading dimension of Q. ldq >= m.
c R (io)        on entry, the upper trapezoidal m-by-n matrix R..
c               on exit, the updated matrix R1.
c ldr (in)      the leading dimension of R. ldr >= k.
c u (io)        the left m-vector. On exit, if k < m, u is destroyed.
c v (io)        the right n-vector. On exit, v is destroyed.
c w (out)       a workspace vector of size 2*k
c
      integer m,n,k,ldq,ldr
      real Q(ldq,*),R(ldr,*),u(*),v(*),w(*)
      external sqrqh,sqhqr,sqrot,sqrtv1
      external saxpy,sdot,snrm2,slamch,sscal,srot
      real sdot,snrm2,slamch,ru,ruu
      integer info,i
      logical full
c quick return if possible.
      if (k == 0 .or. n == 0) return
c check arguments.
      info = 0
      if (m < 0) then
        info = 1
      else if (n < 0) then
        info = 2
      else if (k /= m .and. (k /= n .or. n > m)) then
        info = 3
      else if (ldq < m) then
        info = 5
      else if (ldr < k) then
        info = 7
      endif
      if (info /= 0) then
        call xerbla('SQR1UP',info)
        return
      end if

      full = k == m
c in the non-full case, we shall need the norm of u.
      if (.not.full) ru = snrm2(m,u,1)
c form Q'*u. In the non-full case, form also u - Q*Q'u.
      do i = 1,k
        w(i) = sdot(m,Q(1,i),1,u,1)
        if (.not.full) call saxpy(m,-w(i),Q(1,i),1,u,1)
      end do
c generate rotations to eliminate Q'*u.
      call sqrtv1(k,w,w(k+1))
c apply rotations to R.
      call sqrqh(k,n,R,ldr,w(k+1),w(2))
c apply rotations to Q.
      call sqrot('B',m,k,Q,ldq,w(k+1),w(2))
c update the first row of R.
      call saxpy(n,w(1),v,1,R(1,1),ldr)
c retriangularize R.
      call sqhqr(k,n,R,ldr,w(k+1),w)
c apply rotations to Q.
      call sqrot('F',m,min(k,n+1),Q,ldq,w(k+1),w)
c in the full case, we're finished
      if (full) return
c compute relative residual norm
      ruu = snrm2(m,u,1)
      ru = ru * slamch('e')
      if (ruu <= ru) return
c update the orthogonal basis.
      call sscal(n,ruu,v,1)
      call sscal(m,1e0/ruu,u,1)
      call sch1up(n,R,ldr,v,w(k+1))
      do i = 1,n
        call srot(m,Q(1,i),1,u,1,w(k+i),v(i))
      end do
      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine sqrder(m,n,Q,ldq,R,ldr,j,w)
c purpose:      updates a QR factorization after deleting a row.
c               i.e., given an m-by-m orthogonal matrix Q, an m-by-n
c               upper trapezoidal matrix R and index j in the range
c               1:m, this subroutine updates Q ->Q1 and an R -> R1
c               so that Q1 is again orthogonal, R1 upper trapezoidal,
c               and Q1*R1 = [A(1:j-1,:); A(j+1:m,:)], where A = Q*R.
c               (real version)
c
c arguments:
c m (in)        number of rows of the matrix Q.
c n (in)        number of columns of the matrix R.
c Q (io)        on entry, the orthogonal matrix Q.
c               on exit, the updated matrix Q1.
c ldq (in)      leading dimension of Q. ldq >= m.
c R (io)        on entry, the original matrix R.
c               on exit, the updated matrix R1.
c ldr (in)      leading dimension of R. ldr >= m.
c j (in)        the position of the deleted row.
c w (out)       a workspace vector of size 2*m.
c
      integer m,n,j,ldq,ldr
      real Q(ldq,*),R(ldr,*),w(*)
      external xerbla,scopy,sqrtv1,sqrot,sqrqh
      integer info,i,k
c quick return if possible
      if (m == 1) return
c check arguments
      info = 0
      if (m < 1) then
        info = 1
      else if (j < 1 .or. j > m) then
        info = 7
      end if
      if (info /= 0) then
        call xerbla('SQRDER',info)
        return
      end if
c eliminate Q(j,2:m).
      call scopy(m,Q(j,1),ldq,w,1)
      call sqrtv1(m,w,w(m+1))
c apply rotations to Q.
      call sqrot('B',m,m,Q,ldq,w(m+1),w(2))
c form Q1.
      do k = 1,m-1
        if (j > 1) call scopy(j-1,Q(1,k+1),1,Q(1,k),1)
        if (j < m) call scopy(m-j,Q(j+1,k+1),1,Q(j,k),1)
      end do
c apply rotations to R.
      call sqrqh(m,n,R,ldr,w(m+1),w(2))
c form R1.
      do k = 1,n
        do i = 1,m-1
          R(i,k) = R(i+1,k)
        end do
      end do
      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine sqrdec(m,n,k,Q,ldq,R,ldr,j,w)
c purpose:      updates a QR factorization after deleting
c               a column.
c               i.e., given an m-by-k orthogonal matrix Q, an k-by-n
c               upper trapezoidal matrix R and index j in the range
c               1:n+1, this subroutine updates the matrix Q -> Q1 and
c               R -> R1 so that Q1 remains orthogonal, R1 is upper
c               trapezoidal, and Q1*R1 = [A(:,1:j-1) A(:,j+1:n)],
c               where A = Q*R.
c               (real version)
c arguments:
c m (in)        number of rows of the matrix Q.
c n (in)        number of columns of the matrix R.
c k (in)        number of columns of Q, and rows of R. Must be
c               either k = m (full Q) or k = n < m (economical form,
c               basis dimension will decrease).
c Q (io)        on entry, the unitary m-by-k matrix Q.
c               on exit, the updated matrix Q1.
c ldq (in)      leading dimension of Q. ldq >= m.
c R (io)        on entry, the original matrix R.
c               on exit, the updated matrix R1.
c ldr (in)      leading dimension of R. ldr >= k.
c j (in)        the position of the deleted column in R.
c               1 <= j <= n.
c w (o)         a workspace vector of size k-j.
c
      integer m,n,k,ldq,ldr,j
      real Q(ldq,*),R(ldr,*),w(*)
      external xerbla,scopy,sqhqr,sqrot
      integer info,i
c quick return if possible.
      if (m == 0 .or. n == 0 .or. j == n) return
c check arguments.
      info = 0
      if (m < 0) then
        info = 1
      else if (n < 0) then
        info = 2
      else if (k /= m .and. (k /= n .or. n >= m)) then
        info = 3
      else if (ldq < m) then
        info = 5
      else if (ldr < k) then
        info = 7
      else if (j < 1 .or. j > n+1) then
        info = 8
      end if
      if (info /= 0) then
        call xerbla('SQRDEC',info)
        return
      end if

c delete the j-th column.
      do i = j,n-1
        call scopy(k,R(1,i+1),1,R(1,i),1)
      end do
c retriangularize.
      if (j < k) then
        call sqhqr(k+1-j,n-j,R(j,j),ldr,w,R(1,n))
c apply rotations to Q.
        call sqrot('F',m,min(k,n)+1-j,Q(1,j),ldq,w,R(1,n))
      end if
      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine zchdex(n,R,ldr,j,rw)
c purpose:      given an upper triangular matrix R that is a Cholesky
c               factor of a hermitian positive definite matrix A, i.e.
c               A = R'*R, this subroutine updates R -> R1 so that
c               R1'*R1 = A(jj,jj), where jj = [1:j-1,j+1:n+1].
c               (complex version)
c arguments:
c n (in)        the order of matrix R.
c R (io)        on entry, the original upper trapezoidal matrix R.
c               on exit, the updated matrix R1.
c ldr (in)      leading dimension of R. ldr >= n.
c j (in)        the position of the deleted row/column.
c rw (out)      a real workspace vector of size n.
c
      integer n,ldr,j
      double complex R(ldr,*)
      double precision rw(*)
      integer info,i
      external xerbla,zcopy,zqhqr

c quick return if possible
      if (n == 1) return

c check arguments
      info = 0
      if (n < 0) then
        info = 1
      else if (j < 1 .or. j > n) then
        info = 4
      end if
      if (info /= 0) then
        call xerbla('ZCHDEX',info)
        return
      end if

c delete the j-th column.
      do i = j,n-1
        call zcopy(n,R(1,i+1),1,R(1,i),1)
      end do
c retriangularize.
      if (j < n) then
        call zqhqr(n+1-j,n-j,R(j,j),ldr,rw,R(1,n))
      end if
      end subroutine

c Copyright (C) 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine clup1up(m,n,L,ldl,R,ldr,p,u,v,w)
c purpose:      updates a row-pivoted LU factorization after rank-1 modification
c               i.e., given an m-by-k lower-triangular matrix L with unit
c               diagonal, a k-by-n upper-trapezoidal matrix R, and a 
c               permutation matrix P, where k = min(m,n),
c               this subroutine updates L -> L1, R -> R1 and P -> P1 so that
c               L is again lower unit triangular, R upper trapezoidal,
c               P permutation and P1'*L1*R1 = P'*L*R + u*v.'.
c               (complex version)
c arguments:
c m (in)        order of the matrix L.
c n (in)        number of columns of the matrix U.
c L (io)        on entry, the unit lower triangular matrix L.
c               on exit, the updated matrix L1.
c ldl (in)      the leading dimension of L. ldl >= m.
c R (io)        on entry, the upper trapezoidal m-by-n matrix R.
c               on exit, the updated matrix R1.
c ldr (in)      the leading dimension of R. ldr >= min(m,n).
c p (in)        the permutation vector representing P
c u (in)        the left m-vector.
c v (in)        the right n-vector.
c w (work)      a workspace vector of size m.
c
c REMARK:       Algorithm is due to
c               A. Kielbasinski, H. Schwetlick, Numerische Lineare
c               Algebra, Verlag Harri Deutsch, 1988
c
      integer m,n,ldl,ldr,p(*)
      complex L(ldl,*),R(ldr,*),u(*),v(*),w(*)
      complex one,tmp
      real tau
      parameter (one = 1e0, tau = 1e-1)
      integer k,info,i,j,itmp
      external xerbla,ccopy,caxpy,ctrsv,cgeru,cgemv

c quick return if possible.
      k = min(m,n)
      if (k == 0) return
c check arguments.
      info = 0
      if (m < 0) then
        info = 1
      else if (n < 0) then
        info = 2
      else if (ldl < m) then
        info = 4
      else if (ldr < k) then
        info = 6
      endif
      if (info /= 0) then
        call xerbla('CLU1UP',info)
        return
      end if

c form L \ P*u.
      do i = 1,m
        w(i) = u(p(i))
      end do
      call ctrsv('L','N','U',k,L,ldl,w,1)
c if m > k = n, subtract the trailing part.
      if (m > k) then
        call cgemv('N',m-k,k,-one,L(k+1,1),ldl,w,1,one,w(k+1),1)
      end if
            
c work from bottom to top
      do j = k-1,1,-1
        if (abs(w(j)) < tau * abs(L(j+1,j)*w(j) + w(j+1))) then
c need pivoting. swap j and j+1
          tmp = w(j)
          w(j) = w(j+1)
          w(j+1) = tmp
c update p          
          itmp = p(j)
          p(j) = p(j+1)
          p(j+1) = itmp
c update L
          call cswap(m-j+1,L(j,j),1,L(j,j+1),1)
          call cswap(j+1,L(j,1),ldl,L(j+1,1),ldl)
c update R
          call cswap(n-j+1,R(j,j),ldr,R(j+1,j),ldr)
c make L lower triangular again
          tmp = -L(j,j+1)
          call caxpy(m-j+1,tmp,L(j,j),1,L(j,j+1),1)
c update R
          call caxpy(n-j+1,-tmp,R(j+1,j),ldr,R(j,j),ldr)
c update w
          w(j) = w(j) - tmp*w(j+1)          
        end if
c eliminate w(j+1)
        tmp = w(j+1)/w(j)
        w(j+1) = 0
c update R.
        call caxpy(n-j+1,-tmp,R(j,j),ldr,R(j+1,j),ldr)
c update L.
        call caxpy(m-j,tmp,L(j+1,j+1),1,L(j+1,j),1)
      end do

c add a multiple of v to R
      call caxpy(n,w(1),v,1,R(1,1),ldr)

c forward sweep
      do j = 1,k-1
        if (abs(R(j,j)) < tau * abs(L(j+1,j)*R(j,j) + R(j+1,j))) then
c need pivoting. swap j and j+1
c update p          
          itmp = p(j)
          p(j) = p(j+1)
          p(j+1) = itmp
c update L
          call cswap(m-j+1,L(j,j),1,L(j,j+1),1)
          call cswap(j+1,L(j,1),ldl,L(j+1,1),ldl)
c update R
          call cswap(n-j+1,R(j,j),ldr,R(j+1,j),ldr)
c make L lower triangular again
          tmp = -L(j,j+1)
          call caxpy(m-j+1,tmp,L(j,j),1,L(j,j+1),1)
c update R
          call caxpy(n-j+1,-tmp,R(j+1,j),ldr,R(j,j),ldr)
        end if
c eliminate R(j+1,j)
        tmp = R(j+1,j)/R(j,j)
c update R.
        R(j+1,j) = 0e0
        call caxpy(n-j,-tmp,R(j,j+1),ldr,R(j+1,j+1),ldr)
c update L.
        call caxpy(m-j,tmp,L(j+1,j+1),1,L(j+1,j),1)
      end do

c if m > k = n, complete the update by updating the lower part of L.
      if (m > k) then
        call ccopy(k,v,1,w,1)
        call ctrsv('U','T','N',k,R,ldr,w,1)
        call cgeru(m-k,k,one,w(k+1),1,w,1,L(k+1,1),ldl)
      endif
      end subroutine
      
            

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine zchshx(n,R,ldr,i,j,w,rw)
c purpose:      given an upper triangular matrix R that is a Cholesky
c               factor of a symmetric positive definite matrix A, i.e.
c               A = R'*R, this subroutine updates R -> R1 so that
c               R1'*R1 = A(p,p), where p is the permutation
c               [1:i-1,shift(i:j,-1),j+1:n] if i < j  or
c               [1:j-1,shift(j:i,+1),i+1:n] if j < i.
c               (complex version)
c arguments:
c n (in)        the order of matrix R
c R (io)        on entry, the upper triangular matrix R
c               on exit, the updated matrix R1
c ldr (in)      leading dimension of R. ldr >= n.
c i (in)        the first index determining the range (see above).
c j (in)        the second index determining the range (see above).
c w (o)         a workspace vector of size n.
c rw (o)        a real workspace vector of size n.
c
      integer n,ldr,i,j
      double complex R(ldr,*),w(*)
      double precision rw(*)
      external xerbla,zcopy,zqrtv1,zqrqh,zqhqr
      integer info,l
c quick return if possible.
      if (n == 0 .or. n == 1) return
      info = 0
c check arguments.
      if (n < 0) then
        info = 1
      else if (i < 1 .or. i > n) then
        info = 4
      else if (j < 1 .or. j > n) then
        info = 5
      end if
      if (info /= 0) then
        call xerbla('ZCHSHX',info)
        return
      end if

      if (i < j) then
c shift columns
        call zcopy(n,R(1,i),1,w,1)
        do l = i,j-1
          call zcopy(n,R(1,l+1),1,R(1,l),1)
        end do
        call zcopy(n,w,1,R(1,j),1)
c retriangularize
        call zqhqr(n+1-i,n+1-i,R(i,i),ldr,rw,w)
      else if (j < i) then
c shift columns
        call zcopy(n,R(1,i),1,w,1)
        do l = i,j+1,-1
          call zcopy(n,R(1,l-1),1,R(1,l),1)
        end do
        call zcopy(n,w,1,R(1,j),1)
c eliminate the introduced spike.
        call zqrtv1(n+1-j,R(j,j),rw)
c apply rotations to R
        call zqrqh(n+1-j,n-j,R(j,j+1),ldr,rw,R(j+1,j))
c zero spike.
        do l = j+1,n
          R(l,j) = 0d0
        end do
      end if
      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine zchinx(n,R,ldr,j,u,rw,info)
c purpose:      given an upper triangular matrix R that is a Cholesky
c               factor of a hermitian positive definite matrix A, i.e.
c               A = R'*R, this subroutine updates R -> R1 so that
c               R1'*R1 = A1, A1(jj,jj) = A, A(j,:) = u', A(:,j) = u,
c               jj = [1:j-1,j+1:n+1].
c               (complex version)
c arguments:
c n (in)        the order of matrix R.
c R (io)        on entry, the original upper trapezoidal matrix R.
c               on exit, the updated matrix R1.
c ldr (in)      leading dimension of R. ldr >= n+1.
c j (in)        the position of the inserted row/column
c u (io)        on entry, the inserted row/column.
c               on exit, u is destroyed.
c rw (out)      real workspace vector of size n+1.
c info (out)    on exit, error code:
c                info = 1: update violates positive-definiteness.
c                info = 2: R is singular.
c                info = 3: diagonal element of u is not real.
c
      integer n,j,ldr,info
      double complex R(ldr,*),u(*),rw(*)
      external xerbla,zcopy,dznrm2,ztrsv,zqrtv1,zqrqh
      double complex t
      double precision dznrm2,rho
      integer i

c check arguments
      info = 0
      if (n < 0) then
        info = -1
      else if (j < 1 .or. j > n+1) then
        info = -4
      end if
      if (info /= 0) then
        call xerbla('ZCHINX',info)
        return
      end if

c shift vector.
      t = u(j)
      do i = j,n
        u(i) = u(i+1)
      end do
c the diagonal element must be real.
      if (imag(t) /= 0d0) goto 30

c check for singularity of R.
      do i = 1,n
        if (R(i,i) == 0d0) goto 20
      end do
c form R' \ u
      call ztrsv('U','C','N',n,R,ldr,u,1)
      rho = dznrm2(n,u,1)
c check positive definiteness.
      rho = t - rho**2
      if (rho <= 0d0) goto 10
c shift columns
      do i = n,j,-1
        call zcopy(i,R(1,i),1,R(1,i+1),1)
        R(i+1,i+1) = 0d0
      end do
      call zcopy(n,u,1,R(1,j),1)
      R(n+1,j) = sqrt(rho)
c retriangularize
      if (j < n+1) then
c eliminate the introduced spike.
        call zqrtv1(n+2-j,R(j,j),rw)
c apply rotations to R
        call zqrqh(n+2-j,n+1-j,R(j,j+1),ldr,rw,R(j+1,j))
c zero spike.
        do i = j+1,n+1
          R(i,j) = 0d0
        end do
      end if
c normal return.
      return
c error returns.
 10   info = 1
      return
 20   info = 2
      return
 30   info = 3
      return
      end subroutine
